&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME winChangePassword
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS winChangePassword 
/*------------------------------------------------------------------------

  File: PassWordMeter.w

  Description: Change Password with Password Strength Meter

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: Darrell Woodard

  Created: 06/23/2009

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

DEFINE VARIABLE intpriorStrength   AS INTEGER                NO-UNDO.
DEFINE VARIABLE intCharacterLoop   AS INTEGER                NO-UNDO.
DEFINE VARIABLE intBeginAndEnd   AS INTEGER                NO-UNDO.
DEFINE VARIABLE intSpecialCharacter   AS INTEGER                NO-UNDO.
DEFINE VARIABLE intSpecialSpecial     AS INTEGER                NO-UNDO.
DEFINE VARIABLE intNumberCharacter   AS INTEGER                NO-UNDO.
DEFINE VARIABLE intLCCharacter   AS INTEGER                NO-UNDO.
DEFINE VARIABLE intUCCharacter   AS INTEGER                NO-UNDO.
DEFINE VARIABLE intLength   AS INTEGER                NO-UNDO.
DEFINE VARIABLE logLowerCase        AS LOGICAL INITIAL FALSE  NO-UNDO.
DEFINE VARIABLE logUpperCase        AS LOGICAL INITIAL FALSE  NO-UNDO.
DEFINE VARIABLE logNumber           AS LOGICAL INITIAL FALSE  NO-UNDO.
DEFINE VARIABLE logCharacterCount   AS LOGICAL INITIAL FALSE  NO-UNDO.
DEFINE VARIABLE logBeginAndEnd      AS LOGICAL INITIAL FALSE  NO-UNDO.
DEFINE VARIABLE logSpecialCharacter AS LOGICAL INITIAL FALSE  NO-UNDO.
DEFINE VARIABLE logSpecialSpecial   AS LOGICAL INITIAL FALSE  NO-UNDO.
DEFINE VARIABLE logUserName         AS LOGICAL INITIAL FALSE  NO-UNDO.
DEFINE VARIABLE logFirstName        AS LOGICAL INITIAL FALSE  NO-UNDO.
DEFINE VARIABLE logLastName         AS LOGICAL INITIAL FALSE  NO-UNDO.
DEFINE VARIABLE logNickName         AS LOGICAL INITIAL FALSE  NO-UNDO.
DEFINE VARIABLE logEmpNum           AS LOGICAL INITIAL FALSE  NO-UNDO.
DEFINE VARIABLE logPWC              AS LOGICAL INITIAL FALSE  NO-UNDO.
DEFINE VARIABLE logWordAdded        AS LOGICAL INITIAL FALSE  NO-UNDO.
DEFINE VARIABLE logSucceedingCharacters AS LOGICAL INITIAL FALSE  NO-UNDO.
DEFINE VARIABLE charFirstName       AS CHARACTER FORMAT "x(25)"  NO-UNDO.
DEFINE VARIABLE charNickName        AS CHARACTER FORMAT "x(25)"  NO-UNDO.
DEFINE VARIABLE charLastName        AS CHARACTER FORMAT "x(25)"  NO-UNDO.
DEFINE VARIABLE charFullName        AS CHARACTER FORMAT "x(25)"  NO-UNDO.
DEFINE VARIABLE charUserName        AS CHARACTER FORMAT "x(25)"  NO-UNDO.
DEFINE VARIABLE charEmpNum          AS CHARACTER FORMAT "x(25)"  NO-UNDO.
DEFINE VARIABLE intPreviousCharacter    AS INTEGER NO-UNDO.
DEFINE VARIABLE intSucceedingCharacters AS INTEGER NO-UNDO.
DEFINE VARIABLE intCharPosition AS INTEGER     NO-UNDO.
DEFINE VARIABLE intCharChanges AS INTEGER     NO-UNDO.
DEFINE VARIABLE intWordCount AS INTEGER     NO-UNDO.
DEFINE VARIABLE charWordList AS CHARACTER FORMAT "x(25)"  NO-UNDO.
/* DEFINE VARIABLE charNewPassword     AS CHARACTER FORMAT "x(12)"  NO-UNDO.  */
DEFINE VARIABLE intTypeScale    AS INTEGER                NO-UNDO.
/* Programmer should set the following variables to determine 
   if extra strong passwords are required. 
   Xtra Strong means that all requirements must be met.
   If requirements are not met then colrs are set to red 
   and button is not enabled.
   If Xtra Strong is not required then only the top 2 requirements are needed 
   and the others are suggestions for strengthening password if wanted
*/
DEFINE VARIABLE logXtraStrong AS LOGICAL INITIAL FALSE  NO-UNDO.
/* Set to 12 (red) for Xtra Strong and 14 (Yellow) for regular   */
/* Red means STOP (required), Yellow means CAUTION (recommended) */
/* Colors are set to Green if the criteria is met */
DEFINE VARIABLE intTglBGColor AS INTEGER                NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME DEFAULT-FRAME

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS selStrength filNewPassword filStrengthScale ~
tglLength tglAll4Types tglUpperCase tglNumbers tglLowerCase ~
tglSpecialCharacters tglNotUpperRow tglBeginEnd tglSameCharacter ~
tglSucceeding tglRepeatCharacters tglNotNames tglPreviousPasswords ~
tglDifferent tglForbiddenWords editTips BtnDone 
&Scoped-Define DISPLAYED-OBJECTS selStrength filNewPassword ~
filStrengthScale tglLength tglAll4Types tglUpperCase tglNumbers ~
tglLowerCase tglSpecialCharacters tglNotUpperRow tglBeginEnd ~
tglSameCharacter tglSucceeding tglRepeatCharacters tglNotNames ~
tglPreviousPasswords tglDifferent tglForbiddenWords editTips ~
filForbiddenWords 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR winChangePassword AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON btnChangePassword 
     LABEL "Change Password" 
     SIZE 101 BY 1.62
     FONT 14.

DEFINE BUTTON BtnDone DEFAULT 
     LABEL "&Done" 
     SIZE 101 BY 1.14
     BGCOLOR 8 .

DEFINE VARIABLE editTips AS CHARACTER 
     VIEW-AS EDITOR SCROLLBAR-VERTICAL LARGE
     SIZE 101 BY 13.33 TOOLTIP "Password Tips, Tricks, and Suggestions" NO-UNDO.

DEFINE VARIABLE filForbiddenWords AS CHARACTER FORMAT "X(256)":U 
      VIEW-AS TEXT 
     SIZE 50 BY .86 NO-UNDO.

DEFINE VARIABLE filNewPassword AS CHARACTER FORMAT "X(24)":U 
     LABEL "New Password" 
     VIEW-AS FILL-IN 
     SIZE 33 BY 1 NO-UNDO.

DEFINE VARIABLE filStrengthScale AS INTEGER FORMAT "->,>>>,>>9":U INITIAL 0 
     LABEL "Strength Scale" 
     VIEW-AS FILL-IN 
     SIZE 7 BY 1
     BGCOLOR 12  NO-UNDO.

DEFINE VARIABLE selStrength AS CHARACTER 
     VIEW-AS SELECTION-LIST SINGLE NO-DRAG 
     LIST-ITEMS "<31    = Weak","31-45 = Average","46-60 = Good","61-75 = Strong",">75    = Very Strong" 
     SIZE 26 BY 3.33 NO-UNDO.

DEFINE VARIABLE tglAll4Types AS LOGICAL INITIAL no 
     LABEL "All 4 Types Of Characters (UCase, LCase, Numbers, Special Characters)" 
     VIEW-AS TOGGLE-BOX
     SIZE 75 BY .81 TOOLTIP "Include 4 types of characters: numbers, symbols, upper and lowercase letters"
     BGCOLOR 12  NO-UNDO.

DEFINE VARIABLE tglBeginEnd AS LOGICAL INITIAL no 
     LABEL "Begin and End with a letter" 
     VIEW-AS TOGGLE-BOX
     SIZE 50 BY .81 TOOLTIP "Must not begin or end with a symbol or number"
     BGCOLOR 12  NO-UNDO.

DEFINE VARIABLE tglDifferent AS LOGICAL INITIAL no 
     LABEL "Is significantly different from previous passwords" 
     VIEW-AS TOGGLE-BOX
     SIZE 50 BY .81 TOOLTIP "at least 3 characters different"
     BGCOLOR 12  NO-UNDO.

DEFINE VARIABLE tglForbiddenWords AS LOGICAL INITIAL no 
     LABEL "Forbidden Words" 
     VIEW-AS TOGGLE-BOX
     SIZE 50 BY .81 TOOLTIP "Cannot use dictionary words of 4 characters or more"
     BGCOLOR 12  NO-UNDO.

DEFINE VARIABLE tglLength AS LOGICAL INITIAL no 
     LABEL "Length is 12 to 24 Characters" 
     VIEW-AS TOGGLE-BOX
     SIZE 75 BY .81 TOOLTIP "Length must be between 12 to 24 characters"
     BGCOLOR 12  NO-UNDO.

DEFINE VARIABLE tglLowerCase AS LOGICAL INITIAL no 
     LABEL "At Least 2 Lowercase Characters" 
     VIEW-AS TOGGLE-BOX
     SIZE 50 BY .81 TOOLTIP "At Least 2 Lowercase Characters"
     BGCOLOR 12  NO-UNDO.

DEFINE VARIABLE tglNotNames AS LOGICAL INITIAL no 
     LABEL "No Personal or Company Names" 
     VIEW-AS TOGGLE-BOX
     SIZE 50 BY .81 TOOLTIP "Not user login name, first name, nick name, last name, company name, or acronym"
     BGCOLOR 12  NO-UNDO.

DEFINE VARIABLE tglNotUpperRow AS LOGICAL INITIAL no 
     LABEL "Include Symbol Not On The Upper Row" 
     VIEW-AS TOGGLE-BOX
     SIZE 50 BY .81 TOOLTIP "Include Symbol Not On The Upper Row"
     BGCOLOR 12  NO-UNDO.

DEFINE VARIABLE tglNumbers AS LOGICAL INITIAL no 
     LABEL "At Least 2 Numeric Digits" 
     VIEW-AS TOGGLE-BOX
     SIZE 50 BY .81 TOOLTIP "At Least 2 Numeric Digits"
     BGCOLOR 12  NO-UNDO.

DEFINE VARIABLE tglPreviousPasswords AS LOGICAL INITIAL no 
     LABEL "Not the same as 5 previous passwords" 
     VIEW-AS TOGGLE-BOX
     SIZE 50 BY .81 TOOLTIP "Not the same as 5 previous passwords"
     BGCOLOR 12  NO-UNDO.

DEFINE VARIABLE tglRepeatCharacters AS LOGICAL INITIAL no 
     LABEL "Cannot contain 4 or more repeating characters" 
     VIEW-AS TOGGLE-BOX
     SIZE 50 BY .81 TOOLTIP "Cannot contain 4 or more repeating characters"
     BGCOLOR 12  NO-UNDO.

DEFINE VARIABLE tglSameCharacter AS LOGICAL INITIAL no 
     LABEL "Cannot Contain 4 or more of the same character" 
     VIEW-AS TOGGLE-BOX
     SIZE 50 BY .81 TOOLTIP "Same character not allowed more than 4 times"
     BGCOLOR 12  NO-UNDO.

DEFINE VARIABLE tglSpecialCharacters AS LOGICAL INITIAL no 
     LABEL "At Least 2 Special Characters" 
     VIEW-AS TOGGLE-BOX
     SIZE 50 BY .81 TOOLTIP "At Least 2 Special Characters"
     BGCOLOR 12  NO-UNDO.

DEFINE VARIABLE tglSucceeding AS LOGICAL INITIAL no 
     LABEL "Cannot use 4 or more succeeding characters" 
     VIEW-AS TOGGLE-BOX
     SIZE 50 BY .81 TOOLTIP "Characters must skip a number or letter in a run of 4"
     BGCOLOR 12  NO-UNDO.

DEFINE VARIABLE tglUpperCase AS LOGICAL INITIAL no 
     LABEL "At Least 2 Uppercase Characters" 
     VIEW-AS TOGGLE-BOX
     SIZE 50 BY .81 TOOLTIP "At Least 2 Uppercase Characters"
     BGCOLOR 12  NO-UNDO.

DEFINE BUTTON btnCancel 
     LABEL "Cancel" 
     SIZE 27 BY 1.43.

DEFINE BUTTON btnChangePassword2 
     LABEL "Change Password" 
     SIZE 26 BY 1.43.

DEFINE VARIABLE filConfirmPassword AS CHARACTER FORMAT "X(24)":U 
     LABEL "Re-Enter Password" 
     VIEW-AS FILL-IN 
     SIZE 34 BY 1 NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     selStrength AT ROW 1 COL 77 NO-LABEL WIDGET-ID 44 NO-TAB-STOP 
     filNewPassword AT ROW 1.24 COL 16 COLON-ALIGNED WIDGET-ID 6
     filStrengthScale AT ROW 1.24 COL 65 COLON-ALIGNED WIDGET-ID 38
     tglLength AT ROW 2.43 COL 2 WIDGET-ID 12
     tglAll4Types AT ROW 3.38 COL 2 WIDGET-ID 8
     tglUpperCase AT ROW 4.33 COL 2 WIDGET-ID 20
     tglNumbers AT ROW 4.33 COL 53 WIDGET-ID 24
     tglLowerCase AT ROW 5.29 COL 2 WIDGET-ID 22
     tglSpecialCharacters AT ROW 5.29 COL 53 WIDGET-ID 26
     tglNotUpperRow AT ROW 9.33 COL 2 WIDGET-ID 28
     tglBeginEnd AT ROW 9.33 COL 53 WIDGET-ID 10
     tglSameCharacter AT ROW 7.43 COL 53 WIDGET-ID 36
     tglSucceeding AT ROW 8.38 COL 53 WIDGET-ID 34
     tglRepeatCharacters AT ROW 8.38 COL 2 WIDGET-ID 18
     tglNotNames AT ROW 6.48 COL 53 WIDGET-ID 30
     tglPreviousPasswords AT ROW 6.48 COL 2 WIDGET-ID 14
     tglDifferent AT ROW 7.43 COL 2 WIDGET-ID 32
     tglForbiddenWords AT ROW 10.29 COL 2 WIDGET-ID 16
     btnChangePassword AT ROW 24.57 COL 2 WIDGET-ID 2
     editTips AT ROW 11.24 COL 2 NO-LABEL WIDGET-ID 40 NO-TAB-STOP 
     BtnDone AT ROW 26.24 COL 2 WIDGET-ID 4
     filForbiddenWords AT ROW 10.29 COL 51 COLON-ALIGNED NO-LABEL WIDGET-ID 42 NO-TAB-STOP 
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 102.8 BY 26.43
         DEFAULT-BUTTON BtnDone WIDGET-ID 100.

DEFINE FRAME fraConfirm
     filConfirmPassword AT ROW 1.48 COL 19 COLON-ALIGNED WIDGET-ID 6
     btnCancel AT ROW 2.67 COL 2 WIDGET-ID 4
     btnChangePassword2 AT ROW 2.67 COL 29 WIDGET-ID 2
    WITH 1 DOWN KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 24 ROW 20.05
         SIZE 55 BY 4.29
         TITLE "Confirm NewPassword" WIDGET-ID 200.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW winChangePassword ASSIGN
         HIDDEN             = YES
         TITLE              = "Change Password"
         HEIGHT             = 26.43
         WIDTH              = 102.8
         MAX-HEIGHT         = 26.43
         MAX-WIDTH          = 122
         VIRTUAL-HEIGHT     = 26.43
         VIRTUAL-WIDTH      = 122
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW winChangePassword
  VISIBLE,,RUN-PERSISTENT                                               */
/* REPARENT FRAME */
ASSIGN FRAME fraConfirm:FRAME = FRAME DEFAULT-FRAME:HANDLE.

/* SETTINGS FOR FRAME DEFAULT-FRAME
   FRAME-NAME Custom                                                    */

DEFINE VARIABLE XXTABVALXX AS LOGICAL NO-UNDO.

ASSIGN XXTABVALXX = FRAME fraConfirm:MOVE-AFTER-TAB-ITEM (BtnDone:HANDLE IN FRAME DEFAULT-FRAME)
/* END-ASSIGN-TABS */.

/* SETTINGS FOR BUTTON btnChangePassword IN FRAME DEFAULT-FRAME
   NO-ENABLE                                                            */
ASSIGN 
       editTips:RETURN-INSERTED IN FRAME DEFAULT-FRAME  = TRUE
       editTips:READ-ONLY IN FRAME DEFAULT-FRAME        = TRUE.

/* SETTINGS FOR FILL-IN filForbiddenWords IN FRAME DEFAULT-FRAME
   NO-ENABLE                                                            */
ASSIGN 
       filForbiddenWords:READ-ONLY IN FRAME DEFAULT-FRAME        = TRUE.

/* SETTINGS FOR FRAME fraConfirm
   NOT-VISIBLE                                                          */
ASSIGN 
       FRAME fraConfirm:HIDDEN           = TRUE.

/* SETTINGS FOR BUTTON btnChangePassword2 IN FRAME fraConfirm
   NO-ENABLE                                                            */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(winChangePassword)
THEN winChangePassword:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME winChangePassword
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL winChangePassword winChangePassword
ON END-ERROR OF winChangePassword /* Change Password */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL winChangePassword winChangePassword
ON WINDOW-CLOSE OF winChangePassword /* Change Password */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME fraConfirm
&Scoped-define SELF-NAME btnCancel
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnCancel winChangePassword
ON CHOOSE OF btnCancel IN FRAME fraConfirm /* Cancel */
DO:
  filConfirmPassword = "".
  filConfirmPassword:BGCOLOR = ?.
  DISPLAY 
    filConfirmPassword
    WITH FRAME fraConfirm.
  HIDE FRAME fraConfirm.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME DEFAULT-FRAME
&Scoped-define SELF-NAME btnChangePassword
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnChangePassword winChangePassword
ON CHOOSE OF btnChangePassword IN FRAME DEFAULT-FRAME /* Change Password */
DO:
  VIEW FRAME fraConfirm.
  APPLY "entry" TO filConfirmPassword.
  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME fraConfirm
&Scoped-define SELF-NAME btnChangePassword2
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnChangePassword2 winChangePassword
ON CHOOSE OF btnChangePassword2 IN FRAME fraConfirm /* Change Password */
DO:
  DEFINE BUFFER bufpwHistory FOR dictdb.pwHistory.
  /* change password in _user file */
  dictdb._User._Password = ENCODE(filConfirmPassword).
  /* IS Policy is to remember last 5 passwords
     Find the last password and check the password number
     to see if  5 password history records have been 
     created yet
     Change the number here to reflect any changes in 
     policy on number of passwords to remember
  */
  FIND LAST dictdb.pwHistory
    WHERE dictdb.pwHistory.pwUserLogin = USERID("dictdb")
    USE-INDEX idxUserdate.
  IF dictdb.pwHistory.pwPasswordNumber = 5 THEN
    /* 5 passwords have been recorded */
  DO:
    /* find the oldest password recorded */
    FIND FIRST dictdb.pwHistory
      WHERE dictdb.pwHistory.pwUserLogin = USERID("dictdb")
      USE-INDEX idxUserdate.
    /* overwrite this password with the new changes */
    ASSIGN
      dictdb.pwHistory.DateTimeModified  = NOW
      dictdb.pwHistory.ModifierID  = USERID("dictdb")
      dictdb.pwHistory.pwPassword  = filConfirmPassword
      .
  END.
  ELSE /* less than 5 passwords have been saved */
  DO:
    /* create a new password history record */
    CREATE bufpwHistory.
    ASSIGN
      bufpwHistory.CreatorID = USERID("dictdb")
      bufpwHistory.DateTimeCreated = NOW
      bufpwHistory.DateTimeModified = NOW
      bufpwHistory.ModifierID = USERID("dictdb")
      bufpwHistory.pwPassword = filConfirmPassword
      bufpwHistory.pwPasswordNumber = dictdb.pwHistory.pwPasswordNumber + 1
      bufpwHistory.pwUserLogin = USERID("dictdb")
      bufpwHistory.Status_ = "A"
      .
  END.
  /* pop-up message to let user know that password was successfully changed */
  MESSAGE 
    TODAY STRING(TIME,"hh:mm:ss pm") 
      skip
      "Password for" USERID("dictdb")  "Successfully Changed".
  filConfirmPassword = "".
  btnChangePassword:SENSITIVE IN FRAME default-frame  = FALSE.
  btnChangePassword2:SENSITIVE  = FALSE.
  HIDE FRAME fraConfirm.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME DEFAULT-FRAME
&Scoped-define SELF-NAME BtnDone
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnDone winChangePassword
ON CHOOSE OF BtnDone IN FRAME DEFAULT-FRAME /* Done */
DO:
  &IF "{&PROCEDURE-TYPE}" EQ "SmartPanel" &THEN
    &IF "{&ADM-VERSION}" EQ "ADM1.1" &THEN
      RUN dispatch IN THIS-PROCEDURE ('exit').
    &ELSE
      RUN exitObject.
    &ENDIF
  &ELSE
      APPLY "CLOSE":U TO THIS-PROCEDURE.
  &ENDIF
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME fraConfirm
&Scoped-define SELF-NAME filConfirmPassword
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL filConfirmPassword winChangePassword
ON VALUE-CHANGED OF filConfirmPassword IN FRAME fraConfirm /* Re-Enter Password */
DO:
  ASSIGN filConfirmPassword.
  IF LENGTH(filConfirmPassword)>= LENGTH(filNewPassword) THEN
  DO:
    IF filConfirmPassword = filNewPassword THEN
      /* change confirm password fill-in to green 
      and enable change password button to let user 
      know that the 2 passwords are equal */
    DO:
      filConfirmPassword:BGCOLOR = 10.
      btnChangePassword2:SENSITIVE = TRUE.
    END.
    ELSE
      /* change confirm password fill-in to red 
      and disable change password button to let user 
      know that the 2 passwords are NOT equal */
    DO:
      filConfirmPassword:BGCOLOR = 12.
      btnChangePassword2:SENSITIVE = FALSE.
    END.
  END.
  ELSE /* confirmation password length is still less than the new password entered */
  DO:
    filConfirmPassword:BGCOLOR = ?.
    btnChangePassword2:SENSITIVE = FALSE.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME DEFAULT-FRAME
&Scoped-define SELF-NAME filNewPassword
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL filNewPassword winChangePassword
ON ANY-PRINTABLE OF filNewPassword IN FRAME DEFAULT-FRAME /* New Password */
DO:
  IF LENGTH(filNewPassword) >= 24 THEN
  DO:
    BELL.
    RETURN NO-APPLY.
  END.
/*   List OF ALL printable special characters:                                                                  */
/*   [SPACE] !  "  #  $  %  &  '  (  )  *  +  ,  -  .  /  :  ;  <  =  >  ?  @  [  \  ]  ^  _  `  {  |  }  ~    */
/*   List OF ALLOWED printable special characters:                                            */
/*   [SPACE] !  "  $  %  &  '  (  )  *  +  ,  -  .  :  ;  <  =  >  @  [  ]  ^  _  `  {  |  }  */
/*
ASCII Table of all Allowable Special Characters:
Space                                               32
Exclamation mark        !       33
Quotation mark          "       34
Dollar sign                             $       36
Percent sign                    %       37
Ampersand                                 &     38
Apostrophe                              '       39
Left parenthesis        (       40
Right parenthesis       )       41
Asterisk                                  *     42
Plus sign                                 +     43
Comma                                       ,   44
Hyphen                              -   45
Period (fullstop)       .       46
Colon                                       :   58
Semi-colon                              ;       59
Less than                                 <     60
Equals sign                             =       61
Greater than                    >       62
Commercial at                   @       64
Left square bracket                   [ 91
Right square bracket                ]   93
Caret                                                 ^ 94
Horizontal bar (underscore) _   95
Acute accent                              `     96
Left curly brace                              { 123
Vertical bar                              |     124
Right curly brace                             } 125
*/
/*   List OF NON-ALLOWED printable special characters: */
/*   #  /  ?  ~    */
/*
ASCII Table of all NON-Allowable Special Characters:
Number sign                                           # 35
Delete (rubout), cross-hatch box        127
Question mark                                 ? 63
Tilde                           ~       126
Reverse solidus (backslash)         \   92
Solidus (slash)                       / 47
non-printable characters ASCII > 127
non-printable characters ASCII < 32
*/
  IF    (LASTKEY) = 35 /* Number sign     #     35 */ 
    OR  (LASTKEY) = 127 /* Delete (rubout), cross-hatch box     127 */ 
    OR  (LASTKEY) = 63 /* Question mark                 ?       63 */
    OR  (LASTKEY) = 126 /* Tilde            ~   126 */
    OR  (LASTKEY) = 92 /* Reverse solidus (backslash)   \       92 */
    OR  (LASTKEY) = 47 /* Solidus (slash)               /       47 */
    OR  (LASTKEY) > 127 /* non-printable characters  ASCII > 127 */
    OR  (LASTKEY) < 32  /* non-printable characters ASCII < 32 */
/*   IF    ASC(SUBSTRING(filNewPassword,LASTKEY,1)) = 35 /* Number sign     #     35 */                            */
/*     OR  ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 127 /* Delete (rubout), cross-hatch box     127 */  */
/*     OR  ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 63 /* Question mark                 ?       63 */   */
/*     OR  ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 126 /* Tilde            ~   126 */                  */
/*     OR  ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 92 /* Reverse solidus (backslash)   \       92 */   */
/*     OR  ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 47 /* Solidus (slash)               /       47 */   */
/*     OR  ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) > 127 /* non-printable characters  ASCII > 127 */     */
/*     OR  ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) < 32  /* non-printable characters ASCII < 32 */       */
    THEN
  DO:
    BELL.
    RETURN NO-APPLY.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL filNewPassword winChangePassword
ON VALUE-CHANGED OF filNewPassword IN FRAME DEFAULT-FRAME /* New Password */
DO:
  ASSIGN filNewPassword.
  intpriorStrength = 0.
  filStrengthScale = 0.
  intSpecialCharacter = 0.
  intSpecialSpecial = 0.
  intNumberCharacter = 0.
  intLCCharacter = 0.
  intUCCharacter = 0.
  intBeginAndEnd = 0.
  intLength = 0. 
  intCharPosition = 0.
  intCharChanges = 0.
  charWordList = "".
  IF filNewPassword = ? OR filNewPassword = "" THEN
  DO:
    intPreviousCharacter = 0.
    intSucceedingCharacters = 0.
  END.
  logUserName   = FALSE.
  logFirstName  = FALSE.
  logLastName   = FALSE.
  logNickName   = FALSE.
  logEmpNum     = FALSE.
  logPWC        = FALSE.
  logSucceedingCharacters = FALSE.
  DISPLAY 
    filStrengthScale 
    WITH FRAME default-frame.
  logUpperCase =  FALSE.
  logLowerCase = FALSE.
  logNumber = FALSE.
  logSpecialCharacter = FALSE.
  logNumber = FALSE.
  intpriorStrength = filStrengthScale.
  RUN Check4Types.
/*   MESSAGE                                                 */
/*     "Check4Types"                                         */
/*     SKIP                                                  */
/*     "START Stength" intpriorStrength                      */
/*     SKIP                                                  */
/*     "Strength Added" filStrengthScale - intpriorStrength  */
/*     SKIP                                                  */
/*     "Current Strength" filStrengthScale                   */
/*     VIEW-AS ALERT-BOX INFO BUTTONS OK.                    */
  intpriorStrength = filStrengthScale.
  RUN CheckLength.
/*   MESSAGE                                                 */
/*     "CheckLength"                                         */
/*     SKIP                                                  */
/*     "START Stength" intpriorStrength                      */
/*     SKIP                                                  */
/*     "Strength Added" filStrengthScale - intpriorStrength  */
/*     SKIP                                                  */
/*     "Current Strength" filStrengthScale                   */
/*     VIEW-AS ALERT-BOX INFO BUTTONS OK.                    */
  intpriorStrength = filStrengthScale.
  RUN CheckNames.
/*   MESSAGE                                                 */
/*     "CheckNames"                                          */
/*     SKIP                                                  */
/*     "START Stength" intpriorStrength                      */
/*     SKIP                                                  */
/*     "Strength Added" filStrengthScale - intpriorStrength  */
/*     SKIP                                                  */
/*     "Current Strength" filStrengthScale                   */
/*     VIEW-AS ALERT-BOX INFO BUTTONS OK.                    */
  intpriorStrength = filStrengthScale.
  RUN CheckPreviousPasswords.
/*   MESSAGE                                                 */
/*     "CheckPreviousPasswords"                              */
/*     SKIP                                                  */
/*     "START Stength" intpriorStrength                      */
/*     SKIP                                                  */
/*     "Strength Added" filStrengthScale - intpriorStrength  */
/*     SKIP                                                  */
/*     "Current Strength" filStrengthScale                   */
/*     VIEW-AS ALERT-BOX INFO BUTTONS OK.                    */
/*   IF logXtraStrong = TRUE THEN  */
  DO:
    intpriorStrength = filStrengthScale.
    RUN SymbolNotUpperRow.
/*   MESSAGE                                                 */
/*     "SymbolNotUpperRow" intSpecialSpecial                 */
/*     SKIP                                                  */
/*     "START Stength" intpriorStrength                      */
/*     SKIP                                                  */
/*     "Strength Added" filStrengthScale - intpriorStrength  */
/*     SKIP                                                  */
/*     "Current Strength" filStrengthScale                   */
/*     VIEW-AS ALERT-BOX INFO BUTTONS OK.                    */
    intpriorStrength = filStrengthScale.
    RUN BeginAndEnd.
  /*   MESSAGE                                                 */
  /*     "BeginAndEnd"                                         */
  /*     SKIP                                                  */
  /*     "START Stength" intpriorStrength                      */
  /*     SKIP                                                  */
  /*     "Strength Added" filStrengthScale - intpriorStrength  */
  /*     SKIP                                                  */
  /*     "Current Strength" filStrengthScale                   */
  /*     VIEW-AS ALERT-BOX INFO BUTTONS OK.                    */
    intpriorStrength = filStrengthScale.
    RUN CheckRepeat.
  /*   MESSAGE                                                 */
  /*     "CheckRepeat"                                         */
  /*     SKIP                                                  */
  /*     "START Stength" intpriorStrength                      */
  /*     SKIP                                                  */
  /*     "Strength Added" filStrengthScale - intpriorStrength  */
  /*     SKIP                                                  */
  /*     "Current Strength" filStrengthScale                   */
  /*     VIEW-AS ALERT-BOX INFO BUTTONS OK.                    */
    intpriorStrength = filStrengthScale.
    RUN CheckSucceed.
  /*   MESSAGE                                                 */
  /*     "CheckSucceed"                                        */
  /*     SKIP                                                  */
  /*     "START Stength" intpriorStrength                      */
  /*     SKIP                                                  */
  /*     "Strength Added" filStrengthScale - intpriorStrength  */
  /*     SKIP                                                  */
  /*     "Current Strength" filStrengthScale                   */
  /*     VIEW-AS ALERT-BOX INFO BUTTONS OK.                    */
    intpriorStrength = filStrengthScale.
    RUN CheckSigDiffPW.
  /*   MESSAGE                                                 */
  /*     "CheckSigDiffPW"                                      */
  /*     SKIP                                                  */
  /*     "START Stength" intpriorStrength                      */
  /*     SKIP                                                  */
  /*     "Strength Added" filStrengthScale - intpriorStrength  */
  /*     SKIP                                                  */
  /*     "Current Strength" filStrengthScale                   */
  /*     VIEW-AS ALERT-BOX INFO BUTTONS OK.                    */
    intpriorStrength = filStrengthScale.
    RUN CheckWords.
  /*   MESSAGE                                                 */
  /*     "CheckWords"                                          */
  /*     SKIP                                                  */
  /*     "START Stength" intpriorStrength                      */
  /*     SKIP                                                  */
  /*     "Strength Added" filStrengthScale - intpriorStrength  */
  /*     SKIP                                                  */
  /*     "Current Strength" filStrengthScale                   */
  /*     VIEW-AS ALERT-BOX INFO BUTTONS OK.                    */
  END.
  selStrength = ?.
  IF filStrengthScale < 31  THEN
  DO:
    selStrength = selStrength:ENTRY(1).
    filStrengthScale:BGCOLOR = 12.
  END.
  IF filStrengthScale >= 31 AND filStrengthScale <= 45  THEN
  DO:
    selStrength = selStrength:ENTRY(2).
    filStrengthScale:BGCOLOR = 14.
  END.
  IF filStrengthScale >= 46 AND filStrengthScale <= 60  THEN
  DO:
    selStrength = selStrength:ENTRY(3).
    filStrengthScale:BGCOLOR = 14.
  END.
  IF filStrengthScale >= 61 AND filStrengthScale <= 75  THEN
  DO:
    selStrength = selStrength:ENTRY(4).
    filStrengthScale:BGCOLOR = 10.
  END.
  IF filStrengthScale > 75  THEN
  DO:
    selStrength = selStrength:ENTRY(5).
    filStrengthScale:BGCOLOR = 10.
  END.
  DISPLAY 
    filStrengthScale 
    tglLowerCase
    tglUpperCase
    tglNumbers
    tglSpecialCharacters
    tglNotUpperRow  
    tglBeginEnd
    tglRepeatCharacters
    tglLength
    tglNotNames
    tglDifferent
    tglSucceeding
    tglSameCharacter
    tglForbiddenWords
    tglPreviousPasswords
    filForbiddenWords
    selStrength
    WITH FRAME default-frame.
  IF logXtraStrong = TRUE THEN
  DO:
    IF    tglLowerCase = TRUE
      AND tglUpperCase = TRUE
      AND tglNumbers = TRUE
      AND tglSpecialCharacters = TRUE
      AND tglNotUpperRow   = TRUE
      AND tglBeginEnd = TRUE
      AND tglRepeatCharacters = TRUE
      AND tglLength = TRUE
      AND tglNotNames = TRUE
      AND tglDifferent = TRUE
      AND tglSucceeding = TRUE
      AND tglSameCharacter = TRUE
      AND tglForbiddenWords = TRUE
      AND tglPreviousPasswords   = TRUE
      AND tglAll4Types = TRUE THEN
    DO:
      btnChangePassword:SENSITIVE = TRUE.
    END.
    ELSE
    DO:
      btnChangePassword:SENSITIVE = FALSE.
    END.
  END.
  ELSE
  DO:
    IF    tglLength = TRUE
      AND tglNotNames = TRUE
/*       AND tglUpperCase = TRUE          */
/*       AND tglNumbers = TRUE            */
/*       AND tglSpecialCharacters = TRUE  */
/*       AND tglNotUpperRow   = TRUE      */
/*       AND tglBeginEnd = TRUE           */
/*       AND tglRepeatCharacters = TRUE   */
/*       AND tglLowerCase = TRUE          */
/*       AND tglDifferent = TRUE          */
/*       AND tglSucceeding = TRUE         */
/*       AND tglSameCharacter = TRUE      */
/*       AND tglForbiddenWords = TRUE     */
      AND tglPreviousPasswords   = TRUE
      AND tglAll4Types = TRUE THEN
    DO:
      btnChangePassword:SENSITIVE = TRUE.
    END.
    ELSE
    DO:
      btnChangePassword:SENSITIVE = FALSE.
    END.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME selStrength
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL selStrength winChangePassword
ON VALUE-CHANGED OF selStrength IN FRAME DEFAULT-FRAME
DO:
  /* left this enabled so it can be viewed more easily
    so if user clicks on the list then it runs the checks 
    and resets the selection list to the value it should be
 */
  APPLY "value-changed" TO filNewPassword.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK winChangePassword 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
   RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  logXtraStrong = FALSE. /* Change to True for requiring Xtra Strong Passwords */
  IF logXtraStrong = FALSE THEN
  DO:
    intTglBGColor = 14.
  END.
  ELSE
  DO:
    intTglBGColor = 12.
  END.
  ASSIGN
    tglLowerCase:BGCOLOR          = intTglBGColor
    tglUpperCase:BGCOLOR          = intTglBGColor
    tglNumbers:BGCOLOR            = intTglBGColor
    tglSpecialCharacters:BGCOLOR  = intTglBGColor
    tglNotUpperRow:BGCOLOR        = intTglBGColor
    tglBeginEnd:BGCOLOR           = intTglBGColor
    tglRepeatCharacters:BGCOLOR   = intTglBGColor
    tglDifferent:BGCOLOR          = intTglBGColor
    tglSucceeding:BGCOLOR         = intTglBGColor
    tglSameCharacter:BGCOLOR      = intTglBGColor
    tglForbiddenWords:BGCOLOR     = intTglBGColor
/*     tglPreviousPasswords:BGCOLOR  = intTglBGColor  */
/*     tglNotNames:BGCOLOR           = intTglBGColor  */
    /*   tglLength:BGCOLOR = intTglBGColor  */
    /*   tglAll4Types:BGCOLOR = intTglBGColor  */
    .
  editTips:READ-FILE("P:\password_tips.txt") .
  /* This works with the first connected database */
  /* Get User ID of user connected to DB and place in variable */
  charUserName = USERID(LDBNAME(1)).
  /* Create an alias of the first connected DB that we can work with later on in application */
  CREATE ALIAS "dictdb" FOR DATABASE VALUE(LDBNAME(1)).
  /* Get User Name of User */
  FIND FIRST dictdb._user
    WHERE dictdb._user._userid = USERID(LDBNAME(1))
    NO-LOCK NO-ERROR.
  IF AVAILABLE(dictdb._user) THEN
  DO:
    charFullName = dictdb._user._User-name.
  END.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE BeginAndEnd winChangePassword 
PROCEDURE BeginAndEnd :
/*------------------------------------------------------------------------------
  Purpose:     Make sure that Password starts and ends with a letter character 
               and not a number or special character
  Parameters:  <none>
  Notes:       if first character is a letter and last character is a letter
                then award 2 points for each, check toggle-box
                     and set color of toggle-box to green
               else uncheck toggle-box and set color to red
------------------------------------------------------------------------------*/
    IF   (filNewPassword <> ? AND filNewPassword <> "" AND LENGTH(filNewPassword) > 0) THEN
    DO:
      IF  (SUBSTRING(filNewPassword,1,1)  >= "a" 
       AND SUBSTRING(filNewPassword,1,1)  <= "z") 
       OR  (SUBSTRING(filNewPassword,1,1) >= "A" 
       AND  SUBSTRING(filNewPassword,1,1) <= "Z") 
      THEN
      DO:
        logBeginAndEnd = TRUE.
        intBeginAndEnd = intBeginAndEnd + 2.
      END.
      IF  (SUBSTRING(filNewPassword,LENGTH(filNewPassword),1)  >= "a" 
       AND SUBSTRING(filNewPassword,LENGTH(filNewPassword),1)  <= "z") 
       OR (SUBSTRING(filNewPassword,LENGTH(filNewPassword),1)  >= "A" 
       AND SUBSTRING(filNewPassword,LENGTH(filNewPassword),1)  <= "Z") 
      THEN
      DO:
        intBeginAndEnd = intBeginAndEnd + 2.
      END.
    END.
    ELSE
    DO:
      tglBeginEnd = FALSE.
      tglBeginEnd:BGCOLOR IN FRAME default-frame = intTglBGColor.
    END.
    IF intBeginAndEnd >= 4 THEN
    DO:
      tglBeginEnd = TRUE.
      tglBeginEnd:BGCOLOR IN FRAME default-frame = 10.
      filStrengthScale = filStrengthScale + intBeginAndEnd.
    END.
    ELSE
    DO:
      tglBeginEnd = FALSE.
      tglBeginEnd:BGCOLOR = intTglBGColor.
    END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE Check4Types winChangePassword 
PROCEDURE Check4Types :
/*------------------------------------------------------------------------------
  Purpose:     Make sure all 4 types of Characters are used
  Parameters:  <none>
  Notes:       Award 2 points for each letter, 3 points for each number used,
               and 5 points for each special character used
               If all 4 types are used then check toggle-box and set color to green
               else uncheck toggle-box and set color to red
------------------------------------------------------------------------------*/
  DO intCharacterLoop = 1 TO LENGTH(filNewPassword):
  /* check for special characters */
  /* The pound sign (#) is used as a special character to comment a line in  */
  /* a Progress .pf file and will not work in CONNECT statements via         */
  /* Data Dictionary or Procedure Editor.                                    */
    IF   (ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) GE 32 
      AND ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) LE 47) 
      OR    (ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) GE 58 
         AND ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) LE 64) 
      OR    (ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) GE 91 
         AND ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) LE 96) 
      OR    (ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) GE 123 
         AND ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) LE 127) THEN
    DO:
      logSpecialCharacter = TRUE.
      intSpecialCharacter = intSpecialCharacter + 5.
    END.
    /* check for numbers */
    IF    ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) GE 48 
      AND ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) LE 57 THEN
    DO:
      logNumber = TRUE.
      intNumberCharacter = intNumberCharacter + 3.
    END.
    /* check for uppercase characters */
    IF    ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) GE 65 
      AND ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) LE 90 THEN
    DO:
      logUpperCase = TRUE.
      intUCCharacter = intUCCharacter + 2.
    END.
    /* check for lowercase characters */
    IF    ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) GE 97 
      AND ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) LE 122 THEN
    DO:
      logLowerCase = TRUE.
      intLCCharacter = intLCCharacter + 2.
    END.
  END.
  IF intSpecialCharacter >= 4 THEN
  DO:
    tglSpecialCharacters = TRUE.
    tglSpecialCharacters:BGCOLOR IN FRAME default-frame = 10.
    filStrengthScale = filStrengthScale + intSpecialCharacter.
  END.
  ELSE
  DO:
    tglSpecialCharacters = FALSE.
    tglSpecialCharacters:BGCOLOR = intTglBGColor.
  END.
  IF intNumberCharacter >= 4 THEN
  DO:
    tglNumbers = TRUE.
    tglNumbers:BGCOLOR = 10.
    filStrengthScale = filStrengthScale + intNumberCharacter.
  END.
  ELSE
  DO:
    tglNumbers = FALSE.
    tglNumbers:BGCOLOR = intTglBGColor.
  END.
  IF intUCCharacter >= 4 THEN
  DO:
    tglUpperCase = TRUE.
    tglUpperCase:BGCOLOR = 10.
    filStrengthScale = filStrengthScale + intUCCharacter.
  END.
  ELSE
  DO:
    tglUpperCase = FALSE.
    tglUpperCase:BGCOLOR = intTglBGColor.
  END.
  IF intLCCharacter >= 4 THEN
  DO:
    tglLowerCase = TRUE.
    tglLowerCase:BGCOLOR = 10.
    filStrengthScale = filStrengthScale + intLCCharacter.
  END.
  ELSE
  DO:
    tglLowerCase = FALSE.
    tglLowerCase:BGCOLOR = intTglBGColor.
  END.
  IF    tglLowerCase  = TRUE AND tglUpperCase         = TRUE 
    AND tglNumbers    = TRUE AND tglSpecialCharacters = TRUE THEN
  DO:
    tglAll4Types = TRUE.
    tglAll4Types:BGCOLOR = 10.
  END.
  ELSE
  DO:
    tglAll4Types = FALSE.
    tglAll4Types:BGCOLOR = 12.
  END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE CheckLength winChangePassword 
PROCEDURE CheckLength :
/*------------------------------------------------------------------------------
  Purpose:     Make sure length is 12 to 24 characters
  Parameters:  <none>
  Notes:       if length is 12 to 24 characters then 
                 award 2 points for each letter over 11 characters,
                 check toggle-box, and set color of toggle-box to green
               else uncheck toggle-box and set color to red
  ------------------------------------------------------------------------------*/
  IF LENGTH(filNewPassword) >= 12 THEN
  DO:
    tglLength = TRUE.
    tglLength:BGCOLOR IN FRAME default-frame = 10.
    intLength = (LENGTH(filNewPassword) - 11) * 2.
    filStrengthScale = filStrengthScale + intLength.
  END.
  ELSE
  DO:
    tglLength = FALSE.
    tglLength:BGCOLOR = 12.
  END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE CheckNames winChangePassword 
PROCEDURE CheckNames :
/*------------------------------------------------------------------------------
  Purpose:     Check to ensure names are not used
               Names not allowed are user name, first name, nick name, last 
               name, employee #, company name, and company acronym
  Parameters:  <none>
  Notes:       User Name in _user file must be the same as the employee name 
               in the Payroll DB employee table.
               no points awarded
               If criteria met then check the toggle-box,
                 and change the color of the toggle-box to green
               else uncheck the toggle-box and change the color to red
------------------------------------------------------------------------------*/
IF INDEX(filNewPassword, charUserName) = 0 THEN
  logUserName = TRUE.
    
IF charFullName <> ? AND charFullName <> "" THEN
DO:
  IF NUM-ENTRIES(charFullName," ") > 2 THEN
  DO:
    charLastName  = ENTRY(2,charFullName," ") + " " + ENTRY(3,charFullName," ").
    charFirstName = ENTRY(1,charFullName," ").
  END.
  ELSE
  DO:
    IF NUM-ENTRIES(charFullName," ") = 2 THEN
    DO:
      charLastName  = ENTRY(2,charFullName," ").
      charFirstName = ENTRY(1,charFullName," ").
    END.
    ELSE
    DO:
      charLastName  = charFullName.
      charFirstName = charFullName.
    END.
  END.
  IF charFirstName <> ? AND charFirstName <> "" THEN
  DO:
    IF INDEX(filNewPassword, charFirstName) = 0 THEN
      logFirstName = TRUE.
  END.
  IF charLastName <> ? AND charLastName <> "" THEN
  DO:
    IF INDEX(filNewPassword, charLastName) = 0 THEN
      logLastName = TRUE.
  END.
  IF charNickName <> ? AND charNickName <> "" THEN
  DO:
    IF INDEX(filNewPassword, charNickName) = 0 THEN
      logNickName = TRUE.
  END.
  ELSE
  DO:
    logNickName = TRUE.
  END.
  IF charEmpNum <> ? AND charEmpNum <> "" THEN
  DO:
    charEmpNum = TRIM(charEmpNum,"0").
    IF INDEX(filNewPassword, charEmpNum) = 0 THEN
      logEmpNum = TRUE.
  END.
END.
/* Check for company name and acronym */
IF INDEX(filNewPassword, "PWC") = 0 AND INDEX(filNewPassword, "Public Works") = 0 THEN
      logPWC = TRUE.
IF    logUserName   = TRUE
  AND logFirstName  = TRUE
  AND logLastName   = TRUE
  AND logNickName   = TRUE
  AND logEmpNum     = TRUE 
  AND logPWC        = TRUE THEN
DO:
  tglNotNames = TRUE.
  tglNotNames:BGCOLOR IN FRAME default-frame = 10.
END.
ELSE
DO:
  tglNotNames = FALSE.
  tglNotNames:BGCOLOR IN FRAME default-frame = 12.
END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE CheckPreviousPasswords winChangePassword 
PROCEDURE CheckPreviousPasswords :
/*------------------------------------------------------------------------------
  Purpose:     ensure that previous passwords are not used
  Parameters:  <none>
  Notes:       The number of passwords saved is according to IS Policy
               no points awarded
               If criteria met then check the toggle-box,
                 and change the color of the toggle-box to green
               else uncheck the toggle-box and change the color to red
------------------------------------------------------------------------------*/
FIND FIRST dictdb.pwHistory
  WHERE dictdb.pwHistory.pwUserLogin = USERID("dictdb")
  AND dictdb.pwHistory.pwPassword = filNewPassword
  NO-LOCK NO-ERROR.
IF AVAILABLE(dictdb.pwHistory) THEN
DO:
  tglPreviousPasswords = FALSE.
  tglPreviousPasswords:BGCOLOR IN FRAME default-frame = 12.
END.
ELSE
DO:
  tglPreviousPasswords = TRUE.
  tglPreviousPasswords:BGCOLOR IN FRAME default-frame = 10.
END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE CheckRepeat winChangePassword 
PROCEDURE CheckRepeat :
/*------------------------------------------------------------------------------
  Purpose:     Ensure that 4 or more repeating characters (aaaa, 6666) are not used
  Parameters:  <none>
  Notes:       no points awarded
               If criteria met then check the toggle-box,
                 and change the color of the toggle-box to green
               else uncheck the toggle-box and change the color to red
------------------------------------------------------------------------------*/
logCharacterCount = TRUE.
DO intCharacterLoop = 1 TO LENGTH(filNewPassword). 
  IF NUM-ENTRIES(filNewPassword,SUBSTRING(filNewPassword,intCharacterLoop,1)) - 1 > 3 THEN
  DO:    
    logCharacterCount = FALSE.
  END.
END.
IF logCharacterCount = TRUE THEN
DO:
  tglSameCharacter = TRUE.
  tglSameCharacter:BGCOLOR IN FRAME default-frame = 10.
  tglRepeatCharacters = TRUE.
  tglRepeatCharacters:BGCOLOR IN FRAME default-frame = 10.
END.
ELSE
DO:
  tglSameCharacter = FALSE.
  tglSameCharacter:BGCOLOR = intTglBGColor.
  tglRepeatCharacters = FALSE.
  tglRepeatCharacters:BGCOLOR = intTglBGColor.
END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE CheckSigDiffPW winChangePassword 
PROCEDURE CheckSigDiffPW :
/*------------------------------------------------------------------------------
  Purpose:     Ensure that at least 3 characters are different from passwords
               in password history
  Parameters:  <none>
  Notes:       no points awarded
               If criteria met then check the toggle-box,
                 and change the color of the toggle-box to green
               else uncheck the toggle-box and change the color to red
------------------------------------------------------------------------------*/
tglDifferent = TRUE.
tglDifferent:BGCOLOR IN FRAME default-frame = 10.
FOR EACH dictdb.pwHistory
  WHERE dictdb.pwHistory.pwUserLogin = USERID("dictdb")
/*   AND dictdb.pwHistory.pwPassword = filNewPassword  */
  NO-LOCK .
  IF LENGTH(dictdb.pwHistory.pwPassword) < LENGTH(filNewPassword) THEN
  DO intCharPosition = 1 TO LENGTH(dictdb.pwHistory.pwPassword):
    IF SUBSTRING(dictdb.pwHistory.pwPassword,intCharPosition,1) <> SUBSTRING(dictdb.pwHistory.pwPassword,intCharPosition,1) THEN
    DO:
      intCharChanges = intCharChanges + 1.
    END.
    IF intCharChanges < 3 THEN
    DO:
      tglDifferent = FALSE.
      tglDifferent:BGCOLOR IN FRAME default-frame = intTglBGColor.
    END.
  END.
  ELSE
  DO intCharPosition = 1 TO LENGTH(filNewPassword):
  END.
  IF SUBSTRING(dictdb.pwHistory.pwPassword,intCharPosition,1) <> SUBSTRING(dictdb.pwHistory.pwPassword,intCharPosition,1) THEN
  DO:
    intCharChanges = intCharChanges + 1.
  END.
  IF intCharChanges < 3 THEN
  DO:
    tglDifferent = FALSE.
    tglDifferent:BGCOLOR IN FRAME default-frame = intTglBGColor.
  END.
END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE CheckSucceed winChangePassword 
PROCEDURE CheckSucceed :
/*------------------------------------------------------------------------------
  Purpose:     Ensure that 4 or more succeeding characters (abcd, 1234) are not used
  Parameters:  <none>
  Notes:       no points awarded
               If criteria met then check the toggle-box,
                 and change the color of the toggle-box to green
               else uncheck the toggle-box and change the color to red
------------------------------------------------------------------------------*/
  logSucceedingCharacters = TRUE.
  DO intCharacterLoop = 1 TO LENGTH(filNewPassword):
    IF   ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = intPreviousCharacter + 1
      OR ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = intPreviousCharacter - 1 
      OR intPreviousCharacter = 0 THEN
    DO:
      intSucceedingCharacters = intSucceedingCharacters + 1.
      IF intSucceedingCharacters > 3 THEN
      DO:
        logSucceedingCharacters = FALSE.
      END.
    END.
    ELSE
    DO:
      IF filNewPassword = ? OR filNewPassword = "" THEN
      DO:
        intSucceedingCharacters = 0.
      END.
      ELSE
      DO:
        intSucceedingCharacters = 1.
      END.
    END.
    intPreviousCharacter = ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)).
/*     intPreviousCharacter = ASC(KEYLABEL(LASTKEY)).  */
  END.
  IF logSucceedingCharacters = TRUE THEN
  DO:
    tglSucceeding = TRUE.
    tglSucceeding:BGCOLOR IN FRAME default-frame = 10.
  END.
  ELSE
  DO:
    tglSucceeding = FALSE.
    tglSucceeding:BGCOLOR = intTglBGColor.
  END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE CheckWords winChangePassword 
PROCEDURE CheckWords :
/*------------------------------------------------------------------------------
  Purpose:     Ensure that words in the dictionary of 4 characters or more 
               are not used
  Parameters:  <none>
  Notes:       no points awarded
               If words in the dictionary are used then uncheck the words 
                 toggle-box, change the color of the words toggle-box to red,
                 show the words in the fill-in next to the toggle-box,
                 and change the color of the fill-in to red
               else check the words toggle-box, change the color of the words 
                 toggle-box to green, show the words in the fill-in next to the 
                 toggle-box, and change the color of the fill-in to ? (regular)
------------------------------------------------------------------------------*/
tglForbiddenWords = TRUE.
tglForbiddenWords:BGCOLOR IN FRAME default-frame = 10.
filForbiddenWords:BGCOLOR IN FRAME default-frame = ?.
IF LENGTH(filNewPassword) > 3 THEN
DO:
  DO intCharacterLoop = 1 TO LENGTH(filNewPassword):
    DO intCharPosition = intCharacterLoop TO LENGTH(filNewPassword):
      FIND FIRST dictdb.pwDictionary 
        WHERE dictdb.pwDictionary.pwDictionaryWord = SUBSTRING(filNewPassword,intCharacterLoop,intCharPosition)
        NO-LOCK NO-ERROR.
      IF AVAILABLE(dictdb.pwDictionary) THEN
      DO:    
        tglForbiddenWords = FALSE.
        tglForbiddenWords:BGCOLOR IN FRAME default-frame = intTglBGColor.
        filForbiddenWords:BGCOLOR IN FRAME default-frame = intTglBGColor.
        
        IF charWordList = "" OR charWordList = ? THEN
        DO:
          charWordList = dictdb.pwDictionary.pwDictionaryWord.
        END.
        ELSE
        DO:
          logWordAdded = FALSE.
          DO intWordCount = 1 TO NUM-ENTRIES(charWordList, " "):
            IF ENTRY(intWordCount,charWordList," ") = dictdb.pwDictionary.pwDictionaryWord THEN
            DO:
              logWordAdded = TRUE.
            END.
          END.
          IF logWordAdded = FALSE THEN
          DO:
            charWordList = charWordList + " " + dictdb.pwDictionary.pwDictionaryWord.
          END.
        END.
      END.
    END.
  END.
END.
IF charWordList <> "" AND charWordList <> ? THEN
DO:
  filForbiddenWords = charWordList.
/*   MESSAGE                                                              */
/*     "The following words are dictionary words and are not permitted:"  */
/*     SKIP                                                               */
/*     charWordList                                                       */
/*     VIEW-AS ALERT-BOX INFO BUTTONS OK.                                 */
END.
ELSE
DO:
  filForbiddenWords = "".
END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI winChangePassword  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(winChangePassword)
  THEN DELETE WIDGET winChangePassword.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI winChangePassword  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY selStrength filNewPassword filStrengthScale tglLength tglAll4Types 
          tglUpperCase tglNumbers tglLowerCase tglSpecialCharacters 
          tglNotUpperRow tglBeginEnd tglSameCharacter tglSucceeding 
          tglRepeatCharacters tglNotNames tglPreviousPasswords tglDifferent 
          tglForbiddenWords editTips filForbiddenWords 
      WITH FRAME DEFAULT-FRAME IN WINDOW winChangePassword.
  ENABLE selStrength filNewPassword filStrengthScale tglLength tglAll4Types 
         tglUpperCase tglNumbers tglLowerCase tglSpecialCharacters 
         tglNotUpperRow tglBeginEnd tglSameCharacter tglSucceeding 
         tglRepeatCharacters tglNotNames tglPreviousPasswords tglDifferent 
         tglForbiddenWords editTips BtnDone 
      WITH FRAME DEFAULT-FRAME IN WINDOW winChangePassword.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  DISPLAY filConfirmPassword 
      WITH FRAME fraConfirm IN WINDOW winChangePassword.
  ENABLE filConfirmPassword btnCancel 
      WITH FRAME fraConfirm IN WINDOW winChangePassword.
  {&OPEN-BROWSERS-IN-QUERY-fraConfirm}
  VIEW winChangePassword.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE SymbolNotUpperRow winChangePassword 
PROCEDURE SymbolNotUpperRow :
/*------------------------------------------------------------------------------
  Purpose:     Ensure that at least 1 special character not on the upper row
               (above the numbers) is used
  Parameters:  <none>
  Notes:       If criteria met then award 5 extra points for each special 
                 character not on the upper row, check the toggle-box,
                 and change the color of the toggle-box to green
               else uncheck the toggle-box and change the color to red
------------------------------------------------------------------------------*/
  DO intCharacterLoop = 1 TO LENGTH(filNewPassword):
    IF filNewPassword <> ? AND filNewPassword <> "" AND 
        (ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 32 
      OR ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 34
      OR ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 39
      OR ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 44
      OR ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 46
      OR ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 47
      OR ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 58
      OR ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 59
      OR ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 60
      OR ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 62
      OR ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 63
      OR ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 91
      OR ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 92
      OR ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 93
      OR ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 123
      OR ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 124
      OR ASC(SUBSTRING(filNewPassword,intCharacterLoop,1)) = 125)
      THEN
    DO:
      tglNotUpperRow = TRUE.
      intSpecialSpecial = intSpecialSpecial + 5.
    END.
  END.
  IF intSpecialSpecial >= 2 THEN
  DO:
    tglNotUpperRow = TRUE.
    tglNotUpperRow:BGCOLOR IN FRAME default-frame = 10.
    filStrengthScale = filStrengthScale + intSpecialSpecial.
  END.
  ELSE
  DO:
    tglNotUpperRow = FALSE.
    tglNotUpperRow:BGCOLOR = intTglBGColor.
  END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

